unit Unit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, Menus, StdCtrls, IniFiles;

const Enter = #10+#13;
      Version = '2.0 (26-03-1999)';

type
  THauptseite = class(TForm)
    MainMenu1: TMainMenu;
    DateiMenu: TMenuItem;
    NeueLektion1: TMenuItem;
    Lektionbearbeiten1: TMenuItem;
    N1: TMenuItem;
    Lektionabfragen1: TMenuItem;
    N2: TMenuItem;
    Beenden1: TMenuItem;
    Info1: TMenuItem;
    Panel1: TPanel;
    OpenDialog1: TOpenDialog;
    Einstellungen1: TMenuItem;
    Label1: TLabel;
    procedure Beenden1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure NeueLektion1Click(Sender: TObject);
    procedure Lektionbearbeiten1Click(Sender: TObject);
    procedure Info1Click(Sender: TObject);
    procedure Lektionabfragen1Click(Sender: TObject);
    procedure Einstellungen1Click(Sender: TObject);
    procedure Panel1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Label1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Label1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;
  procedure ShowInfo;
  procedure SavePath;
  procedure LoadPath(DialogNr:Byte);

var
  Hauptseite: THauptseite;
  AktuelleLektion: TFileName;
  f:TextFile;

implementation
uses Unit2,Unit3,Unit4,Unit5;

{$R *.DFM}

procedure THauptseite.Beenden1Click(Sender: TObject);
begin
 Close;
end;

procedure THauptseite.Button1Click(Sender: TObject);
begin
 Hauptseite.Hide;
 LektionBearbeiten.Show;
end;

procedure THauptseite.NeueLektion1Click(Sender: TObject);
begin
 LektionBearbeiten.Caption:='Neue Lektion';
 AktuelleLektion:='';
 Hauptseite.Hide;
 LektionBearbeiten.Show;
end;

procedure SavePath;
var Ini:TIniFile; Path:String;
begin
   Path:=ExtractFilePath(ParamStr(0));
   Ini:=TIniFile.Create(Path+'vokabel.ini');
    Ini.WriteString('Vokabel','Path',ExtractFilePath(AktuelleLektion));
   Ini.Free;
end;

procedure LoadPath(DialogNr:Byte);
var Ini:TIniFile; Path:String;
begin
 Path:=ExtractFilePath(ParamStr(0));
 Ini:=TIniFile.Create(Path+'vokabel.ini');
  case DialogNr of
   1: Hauptseite.OpenDialog1.InitialDir:=Ini.ReadString('Vokabel','Path',Path);
   2: LektionBearbeiten.SaveDialog1.InitialDir:=Ini.ReadString('Vokabel','Path',Path);
  end;
 Ini.Free;
end;

procedure THauptseite.Lektionbearbeiten1Click(Sender: TObject);
begin
 LoadPath(1);
 if OpenDialog1.Execute then
  begin
   AktuelleLektion:=OpenDialog1.FileName;
   LektionBearbeiten.Caption:='Lektion bearbeiten';
   SavePath;
   Hauptseite.Hide;
   LektionBearbeiten.Show;
  end;
end;

procedure THauptseite.Info1Click(Sender: TObject);
begin
 ShowInfo;
end;

procedure ShowInfo;
begin
 Hauptseite.Enabled:=FALSE;
 AboutBox.Enabled:=TRUE;
 AboutBox.Show;
end;

procedure THauptseite.Lektionabfragen1Click(Sender: TObject);
begin
 LoadPath(1);
 if OpenDialog1.Execute then
  begin
   AktuelleLektion:=OpenDialog1.FileName;
   LektionBearbeiten.Caption:='Lektion bearbeiten';
   SavePath;
   Hauptseite.Hide;
   LektionAbfragen.Show;
  end;
end;

procedure THauptseite.Einstellungen1Click(Sender: TObject);
begin
 Hauptseite.Enabled:=FALSE;
 Einstellungen.Show;
end;

procedure THauptseite.Panel1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 if (Button=mbRight) then Label1.Visible:=TRUE;
end;

procedure THauptseite.Panel1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if (Button=mbRight) then Label1.Visible:=FALSE;
end;

procedure THauptseite.Label1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if (Button=mbRight) then Label1.Visible:=FALSE;
end;

procedure THauptseite.Label1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 if (Button=mbRight) then Label1.Visible:=TRUE;
end;

end.
