unit Unit2;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Menus, Buttons, IniFiles;

type
  TLektionBearbeiten = class(TForm)
    MainMenu1: TMainMenu;
    DateiMenu: TMenuItem;
    Beenden1: TMenuItem;
    Info1: TMenuItem;
    Speichern1: TMenuItem;
    Lektionsname: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    VokabelBedeutung1: TEdit;
    VokabelBedeutung2: TEdit;
    VokabelBedeutung3: TEdit;
    VokabelBedeutung4: TEdit;
    VokabelBedeutung5: TEdit;
    VokabelBedeutung6: TEdit;
    Label4: TLabel;
    VokabelBemerkung: TEdit;
    Label5: TLabel;
    VokabelWortliste: TListBox;
    SaveDialog1: TSaveDialog;
    ListVokabelBedeutung1: TListBox;
    ListVokabelBedeutung2: TListBox;
    ListVokabelBedeutung3: TListBox;
    ListVokabelBedeutung4: TListBox;
    ListVokabelBedeutung5: TListBox;
    ListVokabelBedeutung6: TListBox;
    ListVokabelBemerkung: TListBox;
    LabelAnzahl: TLabel;
    N1: TMenuItem;
    Back1: TMenuItem;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    VokabelWort: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure Beenden1Click(Sender: TObject);
    procedure VokabelWortlisteClick(Sender: TObject);
    procedure Info1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure EingabeFelderLeeren;
    procedure Speichern1Click(Sender: TObject);
    procedure LektionSpeichern;
    procedure FormShow(Sender: TObject);
    procedure LektionOpen(Sender: TObject);
    procedure Back1Click(Sender: TObject);
    procedure AllesLeeren(Sender: TObject);
    procedure LektionsnameChange(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  LektionBearbeiten: TLektionBearbeiten;
  VokabelNr: Integer;
  Saved : Boolean;

implementation
uses Unit1,Unit3,Unit4,Unit5;
{$R *.DFM}

procedure TLektionBearbeiten.Button1Click(Sender: TObject);
begin
 Close;
end;

procedure TLektionBearbeiten.Beenden1Click(Sender: TObject);
begin
 Close;
 Hauptseite.Close;
end;

procedure TLektionBearbeiten.VokabelWortlisteClick(Sender: TObject);
begin
 VokabelNr:=VokabelWortliste.ItemIndex;
 VokabelWort.Text:=VokabelWortliste.Items[VokabelNr];
 VokabelBedeutung1.Text:=ListVokabelBedeutung1.Items[VokabelNr];
 VokabelBedeutung2.Text:=ListVokabelBedeutung2.Items[VokabelNr];
 VokabelBedeutung3.Text:=ListVokabelBedeutung3.Items[VokabelNr];
 VokabelBedeutung4.Text:=ListVokabelBedeutung4.Items[VokabelNr];
 VokabelBedeutung5.Text:=ListVokabelBedeutung5.Items[VokabelNr];
 VokabelBedeutung6.Text:=ListVokabelBedeutung6.Items[VokabelNr];
 VokabelBemerkung.Text:=ListVokabelBemerkung.Items[VokabelNr];

end;

procedure TLektionBearbeiten.Info1Click(Sender: TObject);
begin
 ShowInfo;
end;

procedure TLektionBearbeiten.FormClose(Sender: TObject; var Action: TCloseAction);
var b:Word;
begin
 b:=0;
 if not Saved then b:=MessageDlg('Lektion nicht gespeichert!'+Enter
                   +Enter+'Speichern?',mtConfirmation,[mbYes]+[mbNo],0);
 if b=mrYes then Speichern1Click(Sender);
 Hauptseite.Show;
end;

procedure TLektionBearbeiten.EingabeFelderLeeren;
begin
 VokabelWort.Text:='';
 VokabelBedeutung1.Text:='';
 VokabelBedeutung2.Text:='';
 VokabelBedeutung3.Text:='';
 VokabelBedeutung4.Text:='';
 VokabelBedeutung5.Text:='';
 VokabelBedeutung6.Text:='';
 VokabelBemerkung.Text:='';
end;

procedure TLektionBearbeiten.Speichern1Click(Sender: TObject);
begin
 if AktuelleLektion='' then
  begin
   LoadPath(2);
   if SaveDialog1.Execute then
    begin
     AktuelleLektion:=SaveDialog1.FileName;
     SavePath;
    end;
  end;
LektionSpeichern;
end;

procedure TLektionBearbeiten.LektionSpeichern;
var f : TextFile; wort: integer; zeile, path:string; Ini:TIniFile;
begin
 AssignFile(f,AktuelleLektion);
 ReWrite(f);
 WriteLn(f,Lektionsname.Text);
 for wort:=0 to (VokabelWortliste.Items.Count-1) do
  begin
   Zeile:=VokabelWortListe.Items[wort]+'^'+ListVokabelBedeutung1.Items[wort]+'^'+ListVokabelBedeutung2.Items[wort]+'^'+
          ListVokabelBedeutung3.Items[wort]+'^'+ListVokabelBedeutung4.Items[wort]+'^'+ListVokabelBedeutung5.Items[wort]+'^'+
          ListVokabelBedeutung6.Items[wort]+'^'+ListVokabelBemerkung.Items[wort];
   WriteLn(f,Zeile);
   end;
 CloseFile(f);
 Saved:=TRUE;
 Path:=ExtractFilePath(ParamStr(0));
 Ini:=TIniFile.Create(Path+'vokabel.ini');
  Ini.WriteString('Vokabel','Path',ExtractFilePath(AktuelleLektion));
 Ini.Free;
end;

procedure TLektionBearbeiten.FormShow(Sender: TObject);
begin
 AllesLeeren(Sender);
 Saved:=TRUE;
 if AktuelleLektion<>'' then LektionOpen(Sender);
end;

procedure TLektionBearbeiten.AllesLeeren(Sender: TObject);
begin
 Lektionsname.Text:='';
 VokabelWort.Text:='';
 VokabelBedeutung1.Text:='';
 VokabelBedeutung2.Text:='';
 VokabelBedeutung3.Text:='';
 VokabelBedeutung4.Text:='';
 VokabelBedeutung5.Text:='';
 VokabelBedeutung6.Text:='';
 VokabelBemerkung.Text:='';
 VokabelWortliste.Clear;
 ListVokabelBedeutung1.Clear;
 ListVokabelBedeutung2.Clear;
 ListVokabelBedeutung3.Clear;
 ListVokabelBedeutung4.Clear;
 ListVokabelBedeutung5.Clear;
 ListVokabelBedeutung6.Clear;
 ListVokabelBemerkung.Clear;
end;

procedure TLektionBearbeiten.LektionOpen(Sender: TObject);
var f:TextFile; Zeile:String; len:integer;
begin
 AssignFile(f,AktuelleLektion);
 Reset(f);
 ReadLn(f,Zeile);
 Lektionsname.Text:=Zeile;
 repeat
  ReadLn(f,Zeile);
  Len:=pos('^',Zeile);
  VokabelWortliste.Items.Add(copy(Zeile,1,len-1));

  Zeile:=copy(Zeile,len+1,length(Zeile));
  Len:=pos('^',Zeile);
  ListVokabelBedeutung1.Items.Add(copy(Zeile,1,len-1));

  Zeile:=copy(Zeile,len+1,length(Zeile));
  Len:=pos('^',Zeile);
  ListVokabelBedeutung2.Items.Add(copy(Zeile,1,len-1));

  Zeile:=copy(Zeile,len+1,length(Zeile));
  Len:=pos('^',Zeile);
  ListVokabelBedeutung3.Items.Add(copy(Zeile,1,len-1));

  Zeile:=copy(Zeile,len+1,length(Zeile));
  Len:=pos('^',Zeile);
  ListVokabelBedeutung4.Items.Add(copy(Zeile,1,len-1));

  Zeile:=copy(Zeile,len+1,length(Zeile));
  Len:=pos('^',Zeile);
  ListVokabelBedeutung5.Items.Add(copy(Zeile,1,len-1));

  Zeile:=copy(Zeile,len+1,length(Zeile));
  Len:=pos('^',Zeile);
  ListVokabelBedeutung6.Items.Add(copy(Zeile,1,len-1));

  Zeile:=copy(Zeile,len+1,length(Zeile));
  ListVokabelBemerkung.Items.Add(Zeile);

 until Eof(f);
 CloseFile(f);
 LabelAnzahl.Caption:='Anzahl: '+IntToStr(VokabelWortListe.Items.Count);
end;

procedure TLektionBearbeiten.Back1Click(Sender: TObject);
begin
 Close;
end;

procedure TLektionBearbeiten.LektionsnameChange(Sender: TObject);
begin
 Saved:=FALSE;
end;

procedure TLektionBearbeiten.BitBtn1Click(Sender: TObject);
begin
  if VokabelWortListe.ItemIndex<>-1 then
   begin
    VokabelNr:=VokabelWortListe.ItemIndex;
    VokabelWortListe.Items.Delete(VokabelNr);
    ListVokabelBedeutung1.Items.Delete(VokabelNr);
    ListVokabelBedeutung2.Items.Delete(VokabelNr);
    ListVokabelBedeutung3.Items.Delete(VokabelNr);
    ListVokabelBedeutung4.Items.Delete(VokabelNr);
    ListVokabelBedeutung5.Items.Delete(VokabelNr);
    ListVokabelBedeutung6.Items.Delete(VokabelNr);
    ListVokabelBemerkung.Items.Delete(VokabelNr);
    Saved:=FALSE;
    LabelAnzahl.Caption:='Anzahl: '+IntToStr(VokabelWortListe.Items.Count);
  end;
    EingabeFelderLeeren;
    VokabelWort.SetFocus;
end;

procedure TLektionBearbeiten.BitBtn3Click(Sender: TObject);
begin
 VokabelWortliste.Items.Add(VokabelWort.Text);
 ListVokabelBedeutung1.Items.Add(VokabelBedeutung1.Text);
 ListVokabelBedeutung2.Items.Add(VokabelBedeutung2.Text);
 ListVokabelBedeutung3.Items.Add(VokabelBedeutung3.Text);
 ListVokabelBedeutung4.Items.Add(VokabelBedeutung4.Text);
 ListVokabelBedeutung5.Items.Add(VokabelBedeutung5.Text);
 ListVokabelBedeutung6.Items.Add(VokabelBedeutung6.Text);
 ListVokabelBemerkung.Items.Add(VokabelBemerkung.Text);

 EingabeFelderLeeren;
 LabelAnzahl.Caption:='Anzahl: '+IntToStr(VokabelWortListe.Items.Count);
 Saved:=FALSE;
 VokabelWort.SetFocus;
end;

procedure TLektionBearbeiten.BitBtn2Click(Sender: TObject);
begin
 EingabeFelderLeeren;
end;

procedure TLektionBearbeiten.BitBtn4Click(Sender: TObject);
begin
 if (VokabelWortListe.ItemIndex<>-1) and (VokabelWort.Text<>'') then
  begin
    VokabelNr:=VokabelWortListe.ItemIndex;

    VokabelWortliste.Items.Insert(VokabelNr,VokabelWort.Text);
    ListVokabelBedeutung1.Items.Insert(VokabelNr,VokabelBedeutung1.Text);
    ListVokabelBedeutung2.Items.Insert(VokabelNr,VokabelBedeutung2.Text);
    ListVokabelBedeutung3.Items.Insert(VokabelNr,VokabelBedeutung3.Text);
    ListVokabelBedeutung4.Items.Insert(VokabelNr,VokabelBedeutung4.Text);
    ListVokabelBedeutung5.Items.Insert(VokabelNr,VokabelBedeutung5.Text);
    ListVokabelBedeutung6.Items.Insert(VokabelNr,VokabelBedeutung6.Text);
    ListVokabelBemerkung.Items.Insert(VokabelNr,VokabelBemerkung.Text);

    inc(VokabelNr);

    VokabelWortListe.Items.Delete(VokabelNr);
    ListVokabelBedeutung1.Items.Delete(VokabelNr);
    ListVokabelBedeutung2.Items.Delete(VokabelNr);
    ListVokabelBedeutung3.Items.Delete(VokabelNr);
    ListVokabelBedeutung4.Items.Delete(VokabelNr);
    ListVokabelBedeutung5.Items.Delete(VokabelNr);
    ListVokabelBedeutung6.Items.Delete(VokabelNr);
    ListVokabelBemerkung.Items.Delete(VokabelNr);

    Saved:=FALSE;
    LabelAnzahl.Caption:='Anzahl: '+IntToStr(VokabelWortListe.Items.Count);
  end;
    EingabeFelderLeeren;
    VokabelWort.SetFocus;

end;

end.
