unit Unit3;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, StdCtrls, ExtCtrls;

type
  TLektionAbfragen = class(TForm)
    MainMenu1: TMainMenu;
    DateiMenu: TMenuItem;
    Back1: TMenuItem;
    Info1: TMenuItem;
    ListAbfragVokabelWort: TListBox;
    ListAbfragVokabelBedeutung1: TListBox;
    ListAbfragVokabelBedeutung2: TListBox;
    ListAbfragVokabelBedeutung3: TListBox;
    ListAbfragVokabelBedeutung4: TListBox;
    ListAbfragVokabelBedeutung5: TListBox;
    ListAbfragVokabelBedeutung6: TListBox;
    ListAbfragVokabelBemerkung: TListBox;
    ListVokabelAnzahl: TListBox;
    ListZufall: TListBox;
    EditWort: TEdit;
    MemoBedeutungen: TMemo;
    PanelBemerkung: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Button1: TButton;
    LabelAnzahl: TLabel;
    Label4: TLabel;
    PanelKorrektur: TPanel;
    N1: TMenuItem;
    Beenden1: TMenuItem;
    Button2: TButton;
    Label5: TLabel;
    Timer1: TTimer;
    Zeit: TLabel;
    Label6: TLabel;
    procedure Info1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure OpenLektion(Sender: TObject);
    procedure Back1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure EingabeFelderLeeren(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Beenden1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure EditWortKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure AllesLeeren(Sender: TObject);
    procedure MemoBedeutungenKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  LektionAbfragen: TLektionAbfragen;
  w,n,richtige,versuche,return,ZeitSek,ZeitMin:Integer;

implementation
uses Unit1,Unit2,Unit4,Unit5;
{$R *.DFM}

procedure TLektionAbfragen.Info1Click(Sender: TObject);
begin
 ShowInfo;
end;

procedure TLektionAbfragen.FormShow(Sender: TObject);
begin
 if AktuelleLektion<>'' then OpenLektion(Sender);
 Zeit.Caption:='';
 Button1.SetFocus;
 Return:=0;
end;

procedure TLektionAbfragen.AllesLeeren(Sender: TObject);
begin
 richtige:=0;
 versuche:=0;
 w:=0;
 n:=0;
 ListAbfragVokabelWort.Clear;
 ListAbfragVokabelBedeutung1.Clear;
 ListAbfragVokabelBedeutung2.Clear;
 ListAbfragVokabelBedeutung3.Clear;
 ListAbfragVokabelBedeutung4.Clear;
 ListAbfragVokabelBedeutung5.Clear;
 ListAbfragVokabelBedeutung6.Clear;
 ListAbfragVokabelBemerkung.Clear;
 LabelAnzahl.Caption:='0 von 0';
 Button1.Caption:='&Start!';
 EditWort.Text:='';
 MemoBedeutungen.Clear;
 ListVokabelAnzahl.Clear;
 ListZufall.Clear;
 PanelBemerkung.Caption:='';
 PanelKorrektur.Caption:=' ';
end;

procedure TLektionAbfragen.OpenLektion(Sender: TObject);
var f:TextFile; Zeile,z:String; len,i,Anzahl,zufallszahl:integer;
begin
 AllesLeeren(Sender);
 AssignFile(f,AktuelleLektion);
 Reset(f);
 ReadLn(f,Zeile);
 LektionAbfragen.Caption:='Lektion abfragen - [ '+Zeile+' ]';
 repeat
  ReadLn(f,Zeile);
  Len:=pos('^',Zeile);
  ListAbfragVokabelWort.Items.Add(copy(Zeile,1,len-1));

  Zeile:=copy(Zeile,len+1,length(Zeile));
  Len:=pos('^',Zeile);
  ListAbfragVokabelBedeutung1.Items.Add(copy(Zeile,1,len-1));

  Zeile:=copy(Zeile,len+1,length(Zeile));
  Len:=pos('^',Zeile);
  ListAbfragVokabelBedeutung2.Items.Add(copy(Zeile,1,len-1));

  Zeile:=copy(Zeile,len+1,length(Zeile));
  Len:=pos('^',Zeile);
  ListAbfragVokabelBedeutung3.Items.Add(copy(Zeile,1,len-1));

  Zeile:=copy(Zeile,len+1,length(Zeile));
  Len:=pos('^',Zeile);
  ListAbfragVokabelBedeutung4.Items.Add(copy(Zeile,1,len-1));

  Zeile:=copy(Zeile,len+1,length(Zeile));
  Len:=pos('^',Zeile);
  ListAbfragVokabelBedeutung5.Items.Add(copy(Zeile,1,len-1));

  Zeile:=copy(Zeile,len+1,length(Zeile));
  Len:=pos('^',Zeile);
  ListAbfragVokabelBedeutung6.Items.Add(copy(Zeile,1,len-1));

  Zeile:=copy(Zeile,len+1,length(Zeile));
  ListAbfragVokabelBemerkung.Items.Add(Zeile);

 until Eof(f);
 CloseFile(f);

 {Zufallsgenerator-Starten}
 Randomize;
 Anzahl:=ListAbfragVokabelWort.Items.Count;

 for i:=0 to Anzahl-1 do
  begin
   ListVokabelAnzahl.Items.Add(IntToStr(i));
  end;
  zufallszahl:=0;
 for i:=0 to Anzahl-1 do
  begin
   case Einstellungen.WortReihenfolge of
    0: zufallszahl:=0;
    1: zufallszahl:=random(ListVokabelAnzahl.Items.Count);
   end;
   z:=ListVokabelAnzahl.Items[zufallszahl];
   ListZufall.Items.Add(z);
   ListVokabelAnzahl.Items.Delete(zufallszahl);
  end;
end;

procedure TLektionAbfragen.Back1Click(Sender: TObject);
begin
 Close;
 Hauptseite.Show;
end;

procedure TLektionAbfragen.FormClose(Sender: TObject; var Action: TCloseAction);
var Msg,s:string;
begin
Timer1.Enabled:=FALSE;
Msg:='Sie haben '+IntToStr(richtige)+' von '+IntToStr(versuche)
     +' Versuch(en) in '+IntToStr(ZeitMin)+'m'+IntToStr(ZeitSek)
     +'s richtig gelst.';
If versuche<>0 then
  begin
   Str((richtige/versuche)*100:6:2,s);
   Msg:=Msg+Enter+' Das sind '+s+' Prozent.';
   MessageDlg(Msg,mtInformation,[mbOK],0);
  end;

Hauptseite.Show;
end;

procedure TLektionAbfragen.EingabeFelderLeeren(Sender: TObject);
begin
 EditWort.Text:='';
 MemoBedeutungen.Clear;
 PanelBemerkung.Caption:='';
 PanelKorrektur.Caption:='';
end;

procedure TLektionAbfragen.Button1Click(Sender: TObject);
label 1;
begin
 if w=ListAbfragVokabelWort.Items.Count then
  begin
   Close;
   goto 1;
  end;
 if PanelKorrektur.Caption='' then goto 1;
 if LabelAnzahl.Caption='0 von 0' then
  begin
   w:=0;
   Button1.Caption:='&Weiter';
   ZeitSek:=0;
   ZeitMin:=0;
   Timer1.Enabled:=TRUE;
   LabelAnzahl.Caption:=IntToStr(w)+' von '+IntToStr(ListAbfragVokabelWort.Items.Count);
  end;
 EingabeFelderLeeren(Sender);

 if Einstellungen.Abfragerichtung2=2 then
    Einstellungen.Abfragerichtung:=Random(2);

 case Einstellungen.Abfragerichtung of
  0: begin
      EditWort.SetFocus;
      EditWort.ReadOnly:=FALSE;
      MemoBedeutungen.ReadOnly:=TRUE;
     end;
  1: begin
      MemoBedeutungen.SetFocus;
      MemoBedeutungen.ReadOnly:=FALSE;
      EditWort.ReadOnly:=TRUE;
     end;
 end;

 n:=StrToInt(ListZufall.Items[0]);

 case Einstellungen.Abfragerichtung of
  0: begin
      MemoBedeutungen.Lines.Add(ListAbfragVokabelBedeutung1.Items[n]);
      MemoBedeutungen.Lines.Add(ListAbfragVokabelBedeutung2.Items[n]);
      MemoBedeutungen.Lines.Add(ListAbfragVokabelBedeutung3.Items[n]);
      MemoBedeutungen.Lines.Add(ListAbfragVokabelBedeutung4.Items[n]);
      MemoBedeutungen.Lines.Add(ListAbfragVokabelBedeutung5.Items[n]);
      MemoBedeutungen.Lines.Add(ListAbfragVokabelBedeutung6.Items[n]);
      PanelBemerkung.Caption:=ListAbfragVokabelBemerkung.Items[n];
     end;
  1: begin
      EditWort.Text:=ListAbfragVokabelWort.Items[n];
      PanelBemerkung.Caption:=ListAbfragVokabelBemerkung.Items[n];
     end;
 end;

1:
end;

procedure TLektionAbfragen.Beenden1Click(Sender: TObject);
begin
 Close;
 Hauptseite.Close;
end;

procedure TLektionAbfragen.Button2Click(Sender: TObject);
var antwort6,antwort5,antwort4,antwort3,antwort2,antwort1:Boolean;
    Wort : String;
label 1;
begin
if PanelKorrektur.Caption<>'' then goto 1;
Return:=0;
Wort:=IntToStr(w-1);
case Einstellungen.Abfragerichtung of
 0: begin
     if EditWort.Text=ListAbfragVokabelWort.Items[n] then
      begin
       PanelKorrektur.Caption:='RICHTIG!';
       inc(richtige);
       inc(w);
       ListZufall.Items.Delete(0);
      end
      else
      begin
       PanelKorrektur.Caption:='FALSCH!';
       EditWort.Text:=ListAbfragVokabelWort.Items[n];
       ListZufall.Items.Delete(0);
       ListZufall.Items.Insert(Random(ListZufall.Items.Count),IntToStr(n));
      end;
     end;
 1: begin
     if (ListAbfragVokabelBedeutung1.Items[n]='')
      or (ListAbfragVokabelBedeutung1.Items[n]=MemoBedeutungen.Lines[0])
      then antwort1:=TRUE
      else antwort1:=FALSE;
     if (ListAbfragVokabelBedeutung2.Items[n]='')
      or (ListAbfragVokabelBedeutung2.Items[n]=MemoBedeutungen.Lines[1])
      then antwort2:=TRUE
      else antwort2:=FALSE;
     if (ListAbfragVokabelBedeutung3.Items[n]='')
      or (ListAbfragVokabelBedeutung3.Items[n]=MemoBedeutungen.Lines[2])
      then antwort3:=TRUE
      else antwort3:=FALSE;
     if (ListAbfragVokabelBedeutung4.Items[n]='')
      or (ListAbfragVokabelBedeutung4.Items[n]=MemoBedeutungen.Lines[3])
      then antwort4:=TRUE
      else antwort4:=FALSE;
     if (ListAbfragVokabelBedeutung5.Items[n]='')
      or (ListAbfragVokabelBedeutung5.Items[n]=MemoBedeutungen.Lines[4])
      then antwort5:=TRUE
      else antwort5:=FALSE;
     if (ListAbfragVokabelBedeutung6.Items[n]='')
      or (ListAbfragVokabelBedeutung6.Items[n]=MemoBedeutungen.Lines[5])
      then antwort6:=TRUE
      else antwort6:=FALSE;

     if (antwort6=TRUE) and (antwort5=TRUE) and (antwort4=TRUE) and
        (antwort3=TRUE) and (antwort2=TRUE) and (antwort1=TRUE)
      then
      begin
        PanelKorrektur.Caption:='RICHTIG!';
        inc(richtige);
        inc(w);
        ListZufall.Items.Delete(0);
      end
      else
       begin
        PanelKorrektur.Caption:='FALSCH!';
        MemoBedeutungen.Clear;
        MemoBedeutungen.Lines.Add(ListAbfragVokabelBedeutung1.Items[n]);
        MemoBedeutungen.Lines.Add(ListAbfragVokabelBedeutung2.Items[n]);
        MemoBedeutungen.Lines.Add(ListAbfragVokabelBedeutung3.Items[n]);
        MemoBedeutungen.Lines.Add(ListAbfragVokabelBedeutung4.Items[n]);
        MemoBedeutungen.Lines.Add(ListAbfragVokabelBedeutung5.Items[n]);
        MemoBedeutungen.Lines.Add(ListAbfragVokabelBedeutung6.Items[n]);
        ListZufall.Items.Delete(0);
        ListZufall.Items.Insert(Random(ListZufall.Items.Count),IntToStr(n));

       end;
    end;
 end;
 Inc(versuche);
 Button1.SetFocus;
1:
LabelAnzahl.Caption:=IntToStr(w)+' von '+IntToStr(ListAbfragVokabelWort.Items.Count);
end;

procedure TLektionAbfragen.EditWortKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key=VK_Return then Button2Click(Sender);
end;

procedure TLektionAbfragen.MemoBedeutungenKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
 if Key=VK_Return then inc(return);
 if return=6 then Button2Click(Sender);
end;

procedure TLektionAbfragen.Timer1Timer(Sender: TObject);
begin
 if Button1.Caption='&Weiter' then
  begin
   Inc(ZeitSek);
   if ZeitSek=60 then
    begin
     inc(ZeitMin);
     ZeitSek:=0;
    end;
    Zeit.Caption:=IntToStr(ZeitMin)+':'+IntToStr(ZeitSek)
  end;
end;

end.
