unit Unit4;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, Buttons, TabNotBk, IniFiles, FileCtrl;

type
  TEinstellungen = class(TForm)
    Label1: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    RadioAbfrage2: TRadioGroup;
    RadioAbfrage1: TRadioGroup;
    DirectoryListBox1: TDirectoryListBox;
    GroupBox1: TGroupBox;
    procedure BitBtn2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    Abfragerichtung: Byte;
    WortReihenfolge: Byte;
    Abfragerichtung2: Byte;
  end;

var
  Einstellungen: TEinstellungen;

implementation
uses Unit1, Unit2, Unit3, Unit5;
{$R *.DFM}

procedure TEinstellungen.BitBtn2Click(Sender: TObject);
begin
 Close;
end;

procedure TEinstellungen.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
 Hauptseite.Enabled:=TRUE;
end;

procedure TEinstellungen.BitBtn1Click(Sender: TObject);
var Ini: TIniFile; Path: string;
begin
 Path:=ExtractFilePath(ParamStr(0));
 Ini:=TIniFile.Create(Path+'vokabel.ini');
  Ini.WriteString('Vokabel','Version',Version);
  Ini.WriteInteger('Vokabel','Abfrage',RadioAbfrage2.ItemIndex);
  Ini.WriteInteger('Vokabel','Zufall',RadioAbfrage1.ItemIndex);
  Ini.WriteString('Vokabel','Path',DirectoryListBox1.Directory);
 Ini.Free;

 Abfragerichtung:=RadioAbfrage2.ItemIndex;
 WortReihenfolge:=RadioAbfrage1.ItemIndex;
 Abfragerichtung2:=Abfragerichtung;
 Close;
end;

procedure TEinstellungen.FormShow(Sender: TObject);
var Ini:TIniFile; Path:string;

begin
 Path:=ExtractFilePath(ParamStr(0));
 Ini:=TIniFile.Create(Path+'vokabel.ini');
  RadioAbfrage2.ItemIndex:=Ini.ReadInteger('Vokabel','Abfrage',2);
  RadioAbfrage1.ItemIndex:=Ini.ReadInteger('Vokabel','Zufall',1);
  DirectoryListBox1.Directory:=Ini.ReadString('Vokabel','Path',Path);
 Ini.Free;

 Abfragerichtung:=RadioAbfrage2.ItemIndex;
 WortReihenfolge:=RadioAbfrage1.ItemIndex;
 Abfragerichtung2:=Abfragerichtung;
end;

procedure TEinstellungen.FormCreate(Sender: TObject);
begin
 FormShow(Sender);
end;

end.
